/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/*
 * Copyright 2021, 2023-2024 NXP
 */

#ifndef __DT_BINDINGS_S32CC_SCMI_RESET_H
#define __DT_BINDINGS_S32CC_SCMI_RESET_H

#define S32CC_SCMI_RST_BASE_ID	0U
#define S32CC_SCMI_RST(N)		((N) + S32CC_SCMI_RST_BASE_ID)
#define S32CC_PLAT_SCMI_RST(N)	((N) + S32CC_SCMI_PLAT_RST_BASE_ID)

#define S32CC_SCMI_RST_PART0		S32CC_SCMI_RST(0)
#define S32CC_SCMI_RST_PART1		S32CC_SCMI_RST(1)
#define S32CC_SCMI_RST_PART2		S32CC_SCMI_RST(2)
#define S32CC_SCMI_RST_PART3		S32CC_SCMI_RST(3)
#define S32CC_SCMI_RST_CM7_0		S32CC_SCMI_RST(4)
#define S32CC_SCMI_RST_CM7_1		S32CC_SCMI_RST(5)
#define S32CC_SCMI_RST_CM7_2		S32CC_SCMI_RST(6)
#define S32CC_SCMI_RST_DDR		S32CC_SCMI_RST(7)
#define S32CC_SCMI_RST_PCIE0		S32CC_SCMI_RST(8)
#define S32CC_SCMI_RST_SERDES0		S32CC_SCMI_RST(9)
#define S32CC_SCMI_RST_PCIE1		S32CC_SCMI_RST(10)
#define S32CC_SCMI_RST_SERDES1		S32CC_SCMI_RST(11)
#define S32CC_SCMI_RST_A53_0		S32CC_SCMI_RST(12)
#define S32CC_SCMI_RST_A53_1		S32CC_SCMI_RST(13)
#define S32CC_SCMI_RST_A53_2		S32CC_SCMI_RST(14)
#define S32CC_SCMI_RST_A53_3		S32CC_SCMI_RST(15)

#define S32CC_SCMI_PLAT_RST_BASE_ID	S32CC_SCMI_RST(16)
#define S32CC_SCMI_RST_MAX_ID		S32CC_PLAT_SCMI_RST(7)

#endif /* __DT_BINDINGS_S32CC_SCMI_RESET_H */
